using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Input.Touch;
using Microsoft.Xna.Framework.Media;

namespace p11
{

    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;
        Random rand = new Random();
        string text = "Touch Me!";
        SpriteFont Lindsey;
        Vector2 textSize;
        Vector2 textPosition;
        Color textColor = Color.White;

        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";

            TargetElapsedTime = TimeSpan.FromTicks(333333);
        }


        protected override void Initialize()
        {
            // TODO: Add your initialization logic here

            base.Initialize();
        }

        protected override void LoadContent()
        {
            spriteBatch = new SpriteBatch(GraphicsDevice);
            Lindsey = this.Content.Load<SpriteFont>("Lindsey");
            textSize = Lindsey.MeasureString(text);
            Viewport viewport = this.GraphicsDevice.Viewport;
            textPosition = new Vector2((viewport.Width - textSize.X) / 2,
            (viewport.Height - textSize.Y) / 2);
            TouchPanel.EnabledGestures = GestureType.Tap;
        }

        protected override void UnloadContent()
        {

        }

        protected override void Update(GameTime gameTime)
        {
            //     
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
                this.Exit();
            while (TouchPanel.IsGestureAvailable)
            {
                GestureSample gestureSample = TouchPanel.ReadGesture();
                if (gestureSample.GestureType == GestureType.Tap)
                {
                    Vector2 touchPosition = gestureSample.Position;
                    if (touchPosition.X >= textPosition.X &&
                    touchPosition.X < textPosition.X + textSize.X &&
                    touchPosition.Y >= textPosition.Y &&
                    touchPosition.Y < textPosition.Y + textSize.Y)
                    {
                        textColor = new Color((byte)(10), (byte)(50), (byte)(100));
                        text = "You've tapped!";
                    }

                    else
                    {
                        textColor = Color.White;
                    }
                }
            }
            base.Update(gameTime);
        }
        protected override void Draw(GameTime gameTime)
        {
            this.GraphicsDevice.Clear(Color.Coral);
            spriteBatch.Begin();
            spriteBatch.DrawString(Lindsey, text, textPosition, textColor);
            spriteBatch.End();
            base.Draw(gameTime);
        }
    }
}
